#include <iostream>
#include <bits/stdc++.h>
using namespace std;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int_fast64_t n,q;
    cin>>n>>q;
    int_fast64_t dan[n][2];
    int_fast64_t k[q];
    int_fast64_t plazma=0;
    int_fast64_t pojela=0;
    int_fast64_t j = 0;
    int_fast64_t z = 0;
    int_fast64_t c = 0;
    for(int_fast64_t w = 0; w<n;w++)
        cin>>dan[w][0]>>dan[w][1];
    for(int_fast64_t r = 0;r<q;r++)
        cin>>k[r];
    while(c<q)
    {
        while(z<=k[c] && j<n)
        {
            if(j<n)
            {
            if(z==dan[j][0])
            {
               plazma += dan[j][1];
               j++;
            }
            }
            if(plazma>0)
            {
                plazma--;
                pojela++;
            }
            z++;
        }
        z--;
        if(j==n && plazma>0 && k[c]>z)
        {
            if(plazma>k[c]-z)
                pojela+=k[c]-z;
            else
                pojela+=plazma;
            z+=k[c]-z;
        }
        else
            z++;
        cout << pojela << endl;
        c++;
    }

}